class Elem

  include Enumerable

  def initialize(wert,nach=nil)
    @wert = wert
    @nach = nach
  end

  def cons(wert)
    Elem.new(wert,self)
  end

  def wert
    @wert
  end

  def nachfolger
    @nach
  end

  def to_s
    return "(#{@wert},nil)" if @nach == nil
    "(#{@wert},#{@nach})"
  end

  def laenge
    return 1 if @nach == nil
    1 + @nach.laenge
  end
  
  def each &b
    yield wert
    @nach.each &b unless @nach==nil
  end

end

##########################################

def zeige(t,s)
   puts "#{t} \n  => #{s}"
end

e1 = Elem.new(16)
e2 = Elem.new(23,e1)
e3 = e2.cons(30)

zeige("e1.to_s",e1.to_s)
zeige("e2.to_s",e2.to_s)
zeige("e3.to_s",e3.to_s)
puts "\n\n"
  
puts "e3.each {|el| print el.to_s+' '} =>\n"
e3.each {|el| print el.to_s+' '}
puts "\n\n"

# Nur der Iterator each wurde oben implementiert.
# Die unten verwendeden Iteratoren collect (oder map),
# select und reject stammen aus dem eingefgten Modul
# Enumerable und bauen auf each auf.
  
puts "puts e3.collect{|el| (el+1).to_s}.join(' -- ')" +
     " =>\n"
puts e3.collect{|el| (el+1).to_s}.join(' -- ')
puts "\n"
  
puts "puts e3.collect{|el| (el+1).to_s}.sort.join(' <= ')" +
     " =>\n"
puts e3.collect{|el| (el+1).to_s}.sort.join(' <= ')
puts "\n"
  
zeige("e3.select{|el| el%2==1}",
      e3.select{|el| el%2==1}) 
puts "\n"
  
zeige("e3.reject{|el| el%2==1}.join(' ')",
      e3.reject{|el| el%2==1}.join(' '))
puts "\n"
  
puts"---------------------------------\n\n"

##########################################

class Liste

  include Enumerable

  def initialize(elems=nil)
    @elems  = elems
    @laenge = 0 if elems == nil
    @laenge = elems.laenge if elems != nil
    self
  end

  def cons(wert)
    return Liste.new(Elem.new(wert,self.elems)) if @laenge > 0
    Liste.new(Elem.new(wert,nil)) if @laenge == 0
  end

  def elems
    @elems
  end

  def length
    @laenge
  end

  def head
    return "undef" if @laenge == 0
    @elems.wert
  end

  def tail
    return "undef" if @laenge == 0
    Liste.new(@elems.nachfolger)
  end

  def append(liste)
    return Liste.new(liste.elems) if @laenge == 0
    Liste.new(self.tail.append(liste).cons(self.head).elems)
  end

  def to_s
    return "()" if @laenge == 0
    "#{@elems}"
  end
  
  def each &b
    @elems.each &b
  end

end

##########################################

l1 = Liste.new
l2 = Liste.new(e2)
l3 = Liste.new(e3)
l = l2.append(l3)

zeige("l1.to_s",l1.to_s) 
zeige("l2.to_s",l2.to_s) 
zeige("l3.to_s",l3.to_s) 
zeige("l.to_s",l.to_s)   
puts "\n\n"

# Der each-Iterator von Liste stuetzt sich
# unmittelbar ab auf den each-Iterator von Elem.
# Die anderen Iteratoren sind wieder die aus dem
# Modul Enumerable.
  
puts "l.each {|el| print el.to_s+' '} =>\n"
l.each {|el| print el.to_s+' '}
puts "\n\n"
  
puts "puts l.collect{|el| (el+1).to_s}.join(' -- ')" +
     " =>\n"
puts l.collect{|el| (el+1).to_s}.join(' -- ')
puts "\n"
  
puts "puts l.collect{|el| (el+1).to_s}.sort.join(' <= ')" +
     " =>\n"
puts l.collect{|el| (el+1).to_s}.sort.join(' <= ')
puts "\n"
  
zeige("l.select{|el| el%2==1}.join(' ')",
       l.select{|el| el%2==1}.join(' ')) 
puts "\n"
  
zeige("l.reject{|el| el%2==1}.join(' ')",
       l.reject{|el| el%2==1}.join(' '))
puts "\n\n"