require "yaml"

class Elem

  def initialize(wert,nach=nil)
    @wert = wert
    @nach = nach
  end
  
  # Fuer YAML 
  def to_yaml_properties
    %w{ @wert @nach }
  end

  def cons(wert)
    Elem.new(wert,self)
  end

  def wert
    @wert
  end

  def nachfolger
    @nach
  end

  # Fuer YAML so benoetigt:
  def to_s
    "#@wert #@nach"
  end

  def laenge
    return 1 if @nach == nil
    1 + @nach.laenge
  end

end

##########################################

e1 = Elem.new(16)
e2 = Elem.new(23,e1)
e3 = e2.cons(30)

puts "Vorher:  e3 => #{e3}"

File.open("elem.yaml", "w") {|f| YAML.dump(e3, f)}
#data = YAML.dump(e3)

e3 = nil

puts "Mitte:     e3 => #{e3}"
#puts "YAML-data: e3 => \n#{data}"

e3 = YAML.load_file("elem.yaml")
#e3 = YAML.load(data)

puts "Nachher: e3 => #{e3}"

##########################################

class Liste

  def initialize(elems=nil)
    @elems  = elems
    @laenge = 0 if elems == nil
    @laenge = elems.laenge if elems != nil
    self
  end
  
  def to_yaml_properties
    %w{ @elems @laenge }
  end

  def cons(wert)
    return Liste.new(Elem.new(wert,self.elems)) if @laenge > 0
    Liste.new(Elem.new(wert,nil)) if @laenge == 0
  end

  def elems
    @elems
  end

  def length
    @laenge
  end

  def head
    return "undef" if @laenge == 0
    @elems.wert
  end

  def tail
    return "undef" if @laenge == 0
    Liste.new(@elems.nachfolger)
  end

  def append(liste)
    return Liste.new(liste.elems) if @laenge == 0
    Liste.new(self.tail.append(liste).cons(self.head).elems)
  end

  def to_s
    return "()" if @laenge == 0
    "#@elems"
  end

end

##########################################

l1 = Liste.new
l2 = Liste.new(e2)
l3 = Liste.new(e3)
l = l2.append(l3)

puts "Vorher:  l => #{l}"

#File.open("liste.yaml", "w") {|f| YAML.dump(l, f)}
data = YAML.dump(l)

l = nil

puts "Mitte:     l => #{l}"
puts "YAML-data: l => \n#{data}"

#l = YAML.load_file("liste.yaml")
l = YAML.load(data)

puts "Nachher: l => #{l}"