@kleiner20 = %w{ Null ein zwei drei vier fuenf sechs sieben acht neun
                        zehn elf zwoelf dreizehn vierzehn fuenfzehn sechzehn
			siebzehn achtzehn neunzehn}
			
@zehner = %w{ Null zehn zwanzig dreissig vierzig fuenfzig 
                     sechzig siebzig achtzig neunzig}
			
@grosse = %w{ Million Milliarde Billion Billiarde Trillion Trilliarde
                        Quadrillion Quadrilliarde}


def sprichDreier(zahl,singular,plural)
	if zahl == 0 then
		return ""
	elsif zahl == 1 then
		return "ein" + singular
	end
	h = zahl / 100
	r = zahl % 100
	erg = ""
	if h > 0 then
		erg += @kleiner20[h] + "hundert"
	end
	if r > 0 then
		if r == 1 then
			erg += "eins"
		elsif r < 20 then
			erg += @kleiner20[r]
		else
			z = r / 10
			rr = r % 10
			if rr > 0 then
				erg += @kleiner20[rr] 
			end
			if rr > 0 and z > 0 then
				erg += "und"
			end
			if z > 0 then
				erg += @zehner[z]
			end
		end
	end	
	return erg + plural
end

def sprich(zahl)
	if zahl < 1 or zahl >= 10**(3*(@grosse.length+2)) then
		return "unzulaessige Zahl!"
	end
	ds = []
	i = -1
	while zahl > 0
		stellen = zahl % 1000
		zahl = zahl / 1000
		i += 1
		ds[i] = stellen
	end
	erg = ""
	while i > 1 
		gew = @grosse[i-2]
		sing = "e " + gew + " "
		plur =" " + gew + (i%2==1 ? "n " : "en ") 
		erg += sprichDreier(ds[i], sing, plur)
		i -= 1
	end
	if i > 0 then
		erg += sprichDreier(ds[1], "tausend ", "tausend ")
	end
	erg += sprichDreier(ds[0], "s", "")
	erg 
end

def prompt
  puts "Welche Zahl? (Abbruch mit 0)"
  return gets.to_i
end


puts "Kann Zahlen von 1 bis: 10**(" +
       (3*(@grosse.length+2)).to_s + 
       ")-1 aussprechen!\n"
v = prompt
while v != 0
  puts(v.to_s + " wird gesprochen als: "+ sprich(v))
  v = prompt
end