#!/usr/bin/env ruby

require 'fox14'
require 'Grammatiken'
require 'Automaten'
require 'Parser'
require "B_syntaxbume"
include Fox


class ParserWindow < FXDialogBox
   
	 def initialize(owner,currentGrammar)
		super(owner,"Parserfenster...", DECOR_ALL, 0, 0,600,400)
				
				@currentGrammar = currentGrammar
				@currentMachine
				@wordTarget = FXDataTarget.new("")
				contents = FXHorizontalFrame.new(self,LAYOUT_FILL_X|LAYOUT_FILL_Y)

    # Horizontaler Splitter
				splitter = FXSplitter.new(contents, (LAYOUT_SIDE_TOP|LAYOUT_FILL_X|
															LAYOUT_FILL_Y|SPLITTER_TRACKING|SPLITTER_HORIZONTAL))

    # GroupeBox zur Darstellung des Baumes
				groupbox1 = FXGroupBox.new(splitter, "Syntaxbaum",LAYOUT_FILL_X|
															LAYOUT_FILL_Y|FRAME_GROOVE,0,0,150,0)
															
				groupbox2 = FXGroupBox.new(splitter, "Parsingparameter",LAYOUT_FILL_X|
															LAYOUT_FILL_Y|FRAME_GROOVE,0,0,150,0)
															
				groupbox21 = FXGroupBox.new(groupbox2, "Automaten", GROUPBOX_TITLE_CENTER|FRAME_RIDGE)											
															
				@group21_dt = FXDataTarget.new(3)
                @group21_dt.connect(SEL_COMMAND) {
                 case @group21_dt.value
                     when 0
                        @currentNumber = 0
                    when 1
                        @currentNumber = 1
                    when 2
                        @currentNumber = 2
                end
							
                }	
                
                FXRadioButton.new(groupbox21, "LR_0", @group21_dt, FXDataTarget::ID_OPTION)
                FXRadioButton.new(groupbox21, "LR_1",  @group21_dt, FXDataTarget::ID_OPTION + 1)
                FXRadioButton.new(groupbox21, "SLR_1", @group21_dt, FXDataTarget::ID_OPTION + 2)
                FXRadioButton.new(groupbox21, "Kein Automat ausgewhlt", @group21_dt, FXDataTarget::ID_OPTION + 3)
                
								
								# Label und Textfeld fr die Eingabe des Wortes
								FXLabel.new(groupbox2, "Geben Sie das zu berprfende Wort ein:", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
								FXTextField.new(groupbox2, 50, @wordTarget,FXDataTarget::ID_VALUE,
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|
									LAYOUT_LEFT|LAYOUT_FILL_X)
								
								parseButton = FXButton.new(groupbox2, "Parsen", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)	

								parseButton.connect(SEL_COMMAND)do
										case @currentNumber
                     when 0
                        @currentMachine = LR_0.new(@currentGrammar)
                     when 1
                        @currentMachine = LR_1.new(@currentGrammar)
                     when 2
                        @currentMachine = SLR_1.new(@currentGrammar)
                end
										@currentParser = Parser.new(@currentMachine)
										puts @wordTarget.to_s
										tempSyntaxtree = @currentParser.to_SB(@wordTarget.to_s)
										puts tempSyntaxtree.class
										end
	
									
				frame = FXVerticalFrame.new(groupbox1,LAYOUT_FILL_X|LAYOUT_FILL_Y|
																	FRAME_SUNKEN|FRAME_THICK)
		
    # Leere TreeList
				@treeList = FXTreeList.new(frame, nil, 0, (TREELIST_BROWSESELECT|TREELIST_SHOWS_LINES|
															 TREELIST_SHOWS_BOXES|TREELIST_ROOT_BOXES|LAYOUT_FILL_X|
															 LAYOUT_FILL_Y))
  
	
	
	 end
end





class TableWindow < FXDialogBox
   
	 def initialize(owner,mashine,grammar)
		super(owner,"Tabelle der bergangsfunktion...", DECOR_ALL, 0, 0,600,400)
			@currentMashine = mashine
			@currentGrammar = grammar
			
			@table = FXTable.new(self, nil, 0,
      TABLE_COL_SIZABLE|TABLE_ROW_SIZABLE|TABLE_READONLY|LAYOUT_FILL_X|LAYOUT_FILL_Y,
      0,0,0,0, 2,2,2,2)
    
		  @table.setTableSize(@currentMashine.getZustaende.length, 
												  @currentGrammar.getNonterminals.update(@currentGrammar.getTerminals).length+2)

			column = @currentGrammar.getNonterminals.update(@currentGrammar.getTerminals).length+2
			row    = @currentMashine.getZustaende.length
			
			
			
			for i in 0..row-1
				for j in 0..column-1
					@table.setItemJustify(i, j, FXTableItem::CENTER_X|FXTableItem::CENTER_Y)
				end
			end
			
			for i in 0..row-1
				@table.setRowHeight(i,40)
			end
			
			
			uebergaengeArrayOfKonf = @currentMashine.getUebergaenge.array
			zustaendeArrayOfZust = @currentMashine.getZustaende.array
		
		
			alphabetArray = Array.new
			@currentGrammar.getNonterminals.update(@currentGrammar.getTerminals).each{ |x,y|
																					alphabetArray << x}
			alphabetArray = alphabetArray << "S" << "eps"
			alphabetArray = alphabetArray.sort
	
			@table.setBackColor(FXRGB(255, 255, 255))
			@table.setCellColor(0, 0, FXRGB(255, 255, 255))
			@table.setCellColor(0, 1, FXRGB(255, 240, 240))
			@table.setCellColor(1, 0, FXRGB(240, 255, 240))
			@table.setCellColor(1, 1, FXRGB(240, 240, 255))
   
  # Beschriftung der Spaltenkpfe
			(0...alphabetArray.length).each  { |c| @table.setColumnText(c,alphabetArray[c].to_s ) }
    
  # Beschriftung der Zeilenanfnge
			maxString = String.new
			(0...zustaendeArrayOfZust.length).each{|r| @table.setRowText(r, zustaendeArrayOfZust[r].to_s)
									if zustaendeArrayOfZust[r].to_s.length > maxString.length
										maxString = zustaendeArrayOfZust[r].to_s
									end	
								}
			@table.rowHeaderWidth = 5*maxString.length
   
			uebergaengeArrayOfKonf.each{|konf|
							 col = alphabetArray.index(konf[1].to_s)
							 ro  =  zustaendeArrayOfZust.index(konf[0])
							 itemText = @table.getItemText(ro,col)
							 if itemText.length == 0
								@table.setItemText(ro,col , konf[2].to_s)
							 else
								itemText = itemText + " \n" +konf[2].to_s
								@table.setItemText(ro,col , itemText)
							 end
															 }
	end
end


class BrowserWindow < FXDialogBox

  def initialize(owner,nonTermArray,termArray,grammarSICstring)
    
   super(owner,"Grammatik erstellen...", DECOR_ALL, 0, 0,600,400)
   
    contents = FXHorizontalFrame.new(self,LAYOUT_FILL_X|LAYOUT_FILL_Y)

    # Horizontaler Splitter
    splitter = FXSplitter.new(contents, (LAYOUT_SIDE_TOP|LAYOUT_FILL_X|
															LAYOUT_FILL_Y|SPLITTER_TRACKING|SPLITTER_HORIZONTAL))

    # GroupeBox zur Darstellung des Baumes
    groupbox = FXGroupBox.new(splitter, "Grammatik",LAYOUT_FILL_X|
															LAYOUT_FILL_Y|FRAME_GROOVE,0,0,150,0)
    frame = FXHorizontalFrame.new(groupbox,LAYOUT_FILL_X|LAYOUT_FILL_Y|
																	FRAME_SUNKEN|FRAME_THICK)
		
    # Leere TreeList
    @treeList = FXTreeList.new(frame, nil, 0, (TREELIST_BROWSESELECT|TREELIST_SHOWS_LINES|
															 TREELIST_SHOWS_BOXES|TREELIST_ROOT_BOXES|LAYOUT_FILL_X|
															 LAYOUT_FILL_Y))
  
	
	
	
###############################################################	
		if grammarSICstring != nil
			ruleHash = (Grammar.new(grammarSICstring)).getRules
			nonTermArray = [((Grammar.new(grammarSICstring)).getStartsymbol).to_s]
			nonTermArray = nonTermArray + ((Grammar.new(grammarSICstring)).getNonterminals).keys
			nonTermArray = nonTermArray.uniq
			puts nonTermArray
			nonTermArray.each{ |leftSide|	
												@treeList.appendItem(nil, leftSide.to_s)
												@treeList.each{ |left| 
														if left.to_s == leftSide
															ruleHash.each{ |leftRules, rigthRules|
															if leftRules.to_s == left.to_s
																(rigthRules.getAlts).each{ |altern|
																	@treeList.appendItem(left,altern.to_s)
																												 }
															end
																					 }
														end
																			}
											 }
		end
	
		@ruleText		  = String.new()
	  @ruleSign 		= String.new()
	  @ruleComplete = String.new()
	  @grammar			
	
	
		
      # Construct a horizontal frame to hold the main window's contents
      content2 = FXHorizontalFrame.new(splitter,
      LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y, 0, 0, 0, 0, 0, 0, 0, 0)
      
      # Construct a horizontal frame to hold the nontermials
      leftFrame = FXVerticalFrame.new(content2,
      FRAME_SUNKEN|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

      # Construct a horizontal frame to show the arrows
      middleFrame = FXVerticalFrame.new(content2,
      FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)
      
      # Construct a horizontal frame for choosing the terminals
			rightFrame = FXVerticalFrame.new(content2,
      FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

			leftLabel = FXLabel.new(leftFrame, "Linke Regelseite:", nil,
      JUSTIFY_CENTER_X|JUSTIFY_CENTER_Y)
			
     	middleLabel = FXLabel.new(middleFrame, "->", nil,
      JUSTIFY_CENTER_X|JUSTIFY_CENTER_Y,0,0,0,0,0,0,23,0)
			
			rightLabel = FXLabel.new(rightFrame, "Rechte Regelseite:", nil,
      JUSTIFY_CENTER_X|JUSTIFY_CENTER_Y)
			
# Linke Seite				
		
		nonTermTextField = FXTextField.new(leftFrame, 13, nil, TEXTFIELD_READONLY|LAYOUT_SIDE_TOP|LAYOUT_FILL_X)
		
		nonTermComboBox = FXComboBox.new(leftFrame, nonTermArray.length,nil, 0,COMBOBOX_STATIC|
		                          FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP|LAYOUT_FILL_X)
		
		for i in 0..nonTermArray.length-1
		  nonTermComboBox.appendItem(nonTermArray[i].to_s)
		end
		
		nonTermComboBox.connect(SEL_COMMAND)do
		    for i in 0..nonTermArray.length-1 do
		      if nonTermComboBox.itemCurrent?(i)
		        @ruleSign = nonTermComboBox.getItemText(i)
		        nonTermTextField.text = @ruleSign
					end
		    end
		end
	    
	    
# Rechte Seite	
        
		termTextField = FXTextField.new(rightFrame,50,nil, TEXTFIELD_READONLY|LAYOUT_TOP|LAYOUT_FILL_X)
		
		termComboBox = FXComboBox.new(rightFrame, termArray.length,nil, 0,COMBOBOX_STATIC|
		                          FRAME_SUNKEN|FRAME_THICK|LAYOUT_TOP)
		termComboBox.appendItem("eps")
		termComboBox.appendItem("|")		
		for i in 0..termArray.length-1
		 termComboBox.appendItem(termArray[i].to_s)                          
		end
		
		for i in 0..nonTermArray.length-1
		  termComboBox.appendItem(nonTermArray[i].to_s)                          
		end
		
		
		termComboBox.connect(SEL_COMMAND)do
		    for i in 0..(termArray.length+nonTermArray.length+1) do
		      if termComboBox.itemCurrent?(i)
		        @ruleText = @ruleText + termComboBox.getItemText(i)+" "
		        termTextField.text = @ruleText
		      end
		    end
		end



#Button zum Besttigen der Grammatik
	grammarButton = FXButton.new(rightFrame, "Grammatik erzeugen",nil,nil,0,FRAME_THICK|
															FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_CENTER_X|LAYOUT_BOTTOM)
															 
	grammarButton.connect(SEL_COMMAND) do
				grammarSICstring = treeToSIC
			if grammarSICstring != nil
				@grammar = Grammar.new(grammarSICstring)
				owner.leadGrammar(grammarSICstring,@grammar)
			end
	end


#Button zur Besttigung einer Regel	
	commitButton = FXButton.new(rightFrame, "Regel besttigen",nil,nil,0,
															FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_CENTER_X|
															LAYOUT_BOTTOM)
	
	commitButton.connect(SEL_COMMAND)do
	 if ((@ruleSign != "") and (@ruleText != ""))
		@ruleText = @ruleText.chop
		ruleArray = @ruleText.split(" | ")
		ruleArray = ruleArray.uniq
		isNotElem = true
		@treeList.each{ |left|
										if left.to_s == @ruleSign
											isNotElem = false
											ruleArray.each{ |symbole|
																			same = false
																			left.each{ |child|
																									if symbole.to_s == child.to_s
																										same = true
																									end
																								}
																			if !same
																				@treeList.appendItem(left,symbole)
																			end
																		}
										end
									}	
		
		if isNotElem
			@treeList.appendItem(nil,@ruleSign)
			@treeList.each{ |left|
											if left.to_s == @ruleSign
												ruleArray.each{ |symbole| @treeList.appendItem(left,symbole)}
											end
										}
			
		end

		@ruleText = ""
	  @ruleSign = ""
	  nonTermTextField.text = @ruleSign
	  termTextField.text = @ruleText
		puts treeToSIC
	 end
	end





#Button zum Lschen einzelner Symbole aus der aktuellen Regel	
	deleteButton = FXButton.new(rightFrame, "letztes Zeichen lschen",icon,nil,0,
															FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_CENTER_X|LAYOUT_BOTTOM)
	
	deleteButton.connect(SEL_COMMAND)do
	   ruleTemp = @ruleText.split(' ')
	   ruleTemp.delete_at(ruleTemp.length-1)
	   @ruleText = String.new()
	   for i in 0.. ruleTemp.length-1 do
	     @ruleText = @ruleText + ruleTemp[i] + " "
	   end
	   termTextField.text = @ruleText
	end

#Button zum Lschen eines Eintrags der Grammatik
	removeButton = FXButton.new(rightFrame, "Knoten/Blatt lschen",nil,nil,0,FRAME_THICK|
															FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_CENTER_X|LAYOUT_BOTTOM)
															 
	removeButton.connect(SEL_COMMAND) do
				@treeList.each{ |node|
												if @treeList.itemSelected?(node)
													 @itemToDelete = node
												else
													 node.each{|leaf|
																			if @treeList.itemSelected?(leaf)
																				 @itemToDelete = leaf
																			end
																		 }
												end
											}
				@treeList.removeItem(@itemToDelete)
	end


end
  
  
  
	def treeToSIC
		@grammarString = String.new
    @treeList.each{ |left| @grammarString = @grammarString + " \n\n" + 
																						left.to_s + " -> " + rightToSIC(left)}
		@grammarString = @grammarString[3,@grammarString.length-3]
	end

	def rightToSIC(left)
		@rightString = String.new
		left.each{ |right|							
							if right.to_s != "eps"
							 @rightString = @rightString + right.to_s + " \n | "
							else
							 @rightString = @rightString +  " \n | "
							end
							}
		
		string = @rightString[0..@rightString.length-5]
		return string
	end
	
	
end


############################################################################################
############################################################################################

# Klasse DialogWindow dient zum ffnen eines Dialogfensters zur Eingabe
# der Nontermiale, Terminale und des Startsymbols
# Autor: Danilo Ebert

class DialogWindow	< FXDialogBox
	
# Erzeugt ein Dialogfenster mit Defaultwerten
	def initialize(owner, grammarSICstring)
		super(owner,"Grammatik erstellen...", DECOR_ALL, 0, 0,300,400)
		
		
		FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,0,30)		

# Erzeugt DataTargets fr die Eingabe der Nontermiale, Terminale und des Startsymbols
# oder liest diese aus der vorhandenen Grammatik aus
		if grammarSICstring == nil
			@nonTermTarget = FXDataTarget.new("U, V, W")
			@termTarget    = FXDataTarget.new("r, s, t")
		else
			nonTermArray = ((Grammar.new(grammarSICstring)).getNonterminals).keys
			nonTermString = String.new
			while nonTermArray.length > 0
				nonTermString = nonTermString + nonTermArray[0].to_s + ", "
				nonTermArray.delete_at(0)
			end
			nonTermString = nonTermString[0..nonTermString.length-3]
			@nonTermTarget = FXDataTarget.new(nonTermString)
			
			termArray = ((Grammar.new(grammarSICstring)).getTerminals).keys
			termString = String.new
			while termArray.length > 0
				termString = termString + termArray[0].to_s + ", "
				termArray.delete_at(0)
			end
			termString = termString[0..termString.length-3]
			@termTarget    = FXDataTarget.new(termString)
			
		end
		@nonTermArray   = Array.new()
		@termArray      = Array.new()
    
        

# Label und Textfeld fr die Eingabe der NON-Terminale
	FXLabel.new(self, "Liste der NON-Terminale mit Kommata getrennt:", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
	FXTextField.new(self, 50, @nonTermTarget,FXDataTarget::ID_VALUE,
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|
									LAYOUT_LEFT|LAYOUT_FILL_X)

FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,30,30)		

# Label und Textfeld fr die Eingabe der Terminale
	FXLabel.new(self, "Lister der Terminale mit Kommata getrennt:", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
	FXTextField.new(self, 10, @termTarget,FXDataTarget::ID_VALUE,
									LAYOUT_FILL_X|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|LAYOUT_LEFT)

FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,30,30)				


#"Regel"-Button zum Erstellen der Regeln	
	rulesButton = FXButton.new(self, "Regeln erstellen", nil, nil, 0,LAYOUT_CENTER_X|
														FRAME_THICK|FRAME_RAISED|LAYOUT_TOP|LAYOUT_LEFT,
														0, 0, 0, 0, 20, 20, 5, 5)	
	
	rulesButton.connect(SEL_COMMAND) do	
			nonTermTemp = @nonTermTarget.to_s.delete" "
			@nonTermArray = nonTermTemp.split(',')
			
			termTemp = @termTarget.to_s.delete" "
			@termArray = termTemp.split(',')
			
		
			
			ruleWindow =BrowserWindow.new(self,@nonTermArray,@termArray,grammarSICstring)
			ruleWindow.execute
			
	end
 end
 
	def leadGrammar(grammarSICstring,grammar)
		owner.drawGrammar(grammarSICstring,grammar)
	end
	
end


#################################################################################################
###############################################################################################

# Klasse EditorWindow ist die Hauptanwendung zum Erstellen, durcken,
# speichern, laden und modifizieren von Grammatiken.
# Autor: Carolin Bongartz, Robert Meier, Danilo Ebert
class EditorWindow < FXMainWindow

# ffnet einen neue Anwendung des ScribbleFensters
  def initialize(app)
    # Call base class initializer first
    super(app, "Grammatik Editor", nil, nil, DECOR_ALL,
      0, 0, 700, 700)
		
		@currentGrammar
		@grammarSICstring = String.new
		@currentNEA       
		@currentLR0
		@currentLR1
		@currentRel
		
    # Construct a horizontal frame to hold the main window's contents
    @contents = FXHorizontalFrame.new(self,
      LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y, 0, 0, 0, 0, 0, 0, 0, 0)
	
		# Left pane contains the canvas
    @canvasFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)


		# Place a label above the canvas
    FXLabel.new(@canvasFrame, "Grammatik:   SIC-Notation", nil,
      JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    # Horizontal divider line
    FXHorizontalSeparator.new(@canvasFrame, SEPARATOR_GROOVE|LAYOUT_FILL_X)

		@splitter = FXSplitter.new(@canvasFrame, (LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|
															FRAME_THICK|LAYOUT_LEFT|LAYOUT_FILL_X|LAYOUT_FILL_Y|
															SPLITTER_TRACKING|SPLITTER_HORIZONTAL))


    @grammarLabel = FXLabel.new(@splitter, "",nil,JUSTIFY_LEFT|JUSTIFY_TOP|
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|
									LAYOUT_LEFT|LAYOUT_FILL_Y)
   
    
		@ffLabel = FXLabel.new(@splitter, "",nil,JUSTIFY_LEFT|JUSTIFY_TOP|
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|
									LAYOUT_LEFT|LAYOUT_FILL_Y)


 # Right pane for the buttons
    @buttonFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

  
		
		# Label above the buttons
    FXLabel.new(@buttonFrame, "Button Frame", nil,
      JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    # Horizontal divider line
    FXHorizontalSeparator.new(@buttonFrame,
      SEPARATOR_RIDGE|LAYOUT_FILL_X)




	
# DialogBoxButton	zum Erzeugen des Dialogfensters
			dialButton = FXButton.new(@buttonFrame, "Grammatik &erstellen...\tErstellt eine neue Grammatik", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)	

			dialButton.connect(SEL_COMMAND)do
								dialog=DialogWindow.new(self, nil)
								dialog.execute
								end

# DialogBoxButton	zum Erzeugen des Dialogfensters
			dialChangeButton = FXButton.new(@buttonFrame, "Grammatik &ndern...\tndert die aktuelle Grammatik", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)	

			dialChangeButton.connect(SEL_COMMAND)do
				if @grammarSICstring != ""
					dialog=DialogWindow.new(self, @grammarSICstring)
					dialog.execute
					
				else
					loadDialog = FXFileDialog.new(self, "Grammatik laden...")
					if loadDialog.execute != 0
						File.open(loadDialog.filename) do |f|
							@grammarSICstring = (Marshal.load(f))
							drawGrammar(@grammarSICstring,	Grammar.new(@grammarSICstring))
							dialog=DialogWindow.new(self, @grammarSICstring)
							dialog.execute
						end
					end
				end
			end
	
#Save-Button zum Speichern einer erstellten Grammatik
			saveButton = FXButton.new(@buttonFrame, "Grammatik &speichern...\tSpeichert aktuelle Grammatik", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)
			
			saveButton.connect(SEL_COMMAND) do
				saveDialog = FXFileDialog.new(self, "Grammatik speichern...")
				if saveDialog.execute != 0
					File.open(saveDialog.filename,"w") do |f|
						Marshal.dump(@grammarSICstring,f)	
					end
				end
			end

#Load-Button zum Laden einer gespeicherten Grammatik	
			loadButton = FXButton.new(@buttonFrame, "Grammatik &laden...\tLd eine gespeicherte Grammatik", nil,
																nil,FXWindow::ID_SHOW,
																(FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT),
																0, 0, 0, 0, 10, 10, 5, 5)
			loadButton.connect(SEL_COMMAND) do
				loadDialog = FXFileDialog.new(self, "Grammatik laden...")
				if loadDialog.execute != 0
					File.open(loadDialog.filename) do |f|
						@grammarSICstring = (Marshal.load(f))
						drawGrammar(@grammarSICstring,	Grammar.new(@grammarSICstring))					
					end
				end
			end

FXHorizontalSeparator.new(@buttonFrame, SEPARATOR_GROOVE|LAYOUT_FILL_X,0,0,0,0,0,0,15,15)

#NEA-Button zum Erzeugen des NEA zur Grammatik	
			neaButton = FXButton.new(@buttonFrame, "NE&A...\tErzeugt den NEA zur aktuellen Grammatik", nil,
																nil,FXWindow::ID_SHOW,
																(FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT),
																0, 0, 0, 0, 0, 10, 5, 5)

			neaButton.connect(SEL_COMMAND) do
				if @currentGrammar != nil
					 @currentNEA = NEA.new(@currentGrammar)
					 tableWindow = TableWindow.new(self,@currentNEA,@currentGrammar)
					 puts @currentNEA.to_s
					 tableWindow.execute
				end
			end

#LR_0-Button zum Erzeugen des LR_0-Automaten zur Grammatik	
			lr0Button = FXButton.new(@buttonFrame, "LR_&0...\tErzeugt den LR_-Automaten zur aktuellen Grammatik", nil,
																nil,FXWindow::ID_SHOW,
																(FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT),
																0, 0, 0, 0, 10, 10, 5, 5)



			lr0Button.connect(SEL_COMMAND)do
				if @currentGrammar != nil
					 @currentLR0 = LR_0.new(@currentGrammar)
					 tableWindow = TableWindow.new(self,@currentLR0,@currentGrammar)
					 tableWindow.execute
					 puts @currentLR0.to_s
				end
			end
	
	
#LR_1-Button zum Erzeugen des LR_1-Automaten zur Grammatik	
			lr1Button = FXButton.new(@buttonFrame, "LR_&1...\tErzeugt den LR_1-Automaten zur aktuellen Grammatik", nil,
																nil,FXWindow::ID_SHOW,
																(FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT),
																0, 0, 0, 0, 10, 10, 5, 5)



			lr1Button.connect(SEL_COMMAND)do
				if @currentGrammar != nil
					 @currentLR1 = LR_1.new(@currentGrammar)
					 tableWindow = TableWindow.new(self,@currentLR1,@currentGrammar)
					 tableWindow.execute
					 puts @currentLR1.to_s
				end
			end	
	
	
#SLR_1-Button zum Erzeugen des SLR_1-Automaten zur Grammatik	
			slr1Button = FXButton.new(@buttonFrame, "SLR_&1...\tErzeugt den SLR_1-Automaten zur aktuellen Grammatik", nil,
																nil,FXWindow::ID_SHOW,
																(FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT),
																0, 0, 0, 0, 10, 10, 5, 5)



			slr1Button.connect(SEL_COMMAND)do
				if @currentGrammar != nil
					 @currentSLR1 = SLR_1.new(@currentGrammar)
					 tableWindow = TableWindow.new(self,@currentSLR1,@currentGrammar)
					 tableWindow.execute
					 puts @currentSLR1.to_s
				end
			end	
	
#First- und Follow-Button zur Grammatik	
			ffButton = FXButton.new(@buttonFrame, "First-und Follow...\tErzeugt die First- und Followmengen zur aktuellen Grammatik", nil,
																nil,FXWindow::ID_SHOW,
																(FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT),
																0, 0, 0, 0, 10, 10, 5, 5)
			
			ffButton.connect(SEL_COMMAND)do
			   if (@currentGrammar!= nil)
				@currentParserRel = ParserRelation.new(@currentGrammar)
				firstString = @currentParserRel.FirstSets[0,@currentParserRel.FirstSets.length-1]
				followString = @currentParserRel.FollowSets[0,@currentParserRel.FollowSets.length-1]
				@ffLabel.text = "FIRST-Mengen:" + "\n\n" + firstString + "\n\n" + "FOLLOW-Mengen:" + "\n\n" + followString
			  end
			end

FXHorizontalSeparator.new(@buttonFrame, SEPARATOR_GROOVE|LAYOUT_FILL_X,0,0,0,0,0,0,15,15)


			parserButton = FXButton.new(@buttonFrame, "&Parser...\tErzeugt einen Parser zu einem Automaten", nil,
																nil,FXWindow::ID_SHOW,
																(FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT),
																0, 0, 0, 0, 10, 10, 5, 5)
			parserButton.connect(SEL_COMMAND)do
			     if (@currentGrammar!= nil)
				parserWindow = ParserWindow.new(self,@currentGrammar)
				parserWindow.execute
				end
              end


# Exit button
			FXButton.new(@buttonFrame, "E&xit\tBeendet die Anwendung", nil, app, FXApp::ID_QUIT,
									 FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_BOTTOM|LAYOUT_LEFT,
									 0, 0, 0, 0, 10, 10, 5, 5)

  
	end


	def drawGrammar(grammarSICstring,grammar)
		@grammarSICstring = grammarSICstring
		@currentGrammar = grammar
		@grammarLabel.text = @currentGrammar.to_SIC
		
	end



  # Create and show the main window
  def create
    super                  # Create the windows
    show(PLACEMENT_SCREEN) # Make the main window appear
  end


end




if __FILE__ == $0
  # Construct the application object
  application = FXApp.new('Grammar', 'Editor')
  
  # Construct the main window
  editor = EditorWindow.new(application)
  
  # Create the application
  application.create
  
  # Run the application
  application.run
end